/*!
  * vue-i18n v12.0.0-alpha.2
  * (c) 2016-present kazuya kawaguchi and contributors
  * Released under the MIT License.
  */
import{createVNode,Text,computed,watch,getCurrentInstance,ref,shallowRef,Fragment,h,defineComponent,effectScope,inject,onMounted,onUnmounted,isRef}from"vue";const inBrowser="undefined"!=typeof window,makeSymbol=(e,t=!1)=>t?Symbol.for(e):Symbol(e),generateFormatCacheKey=(e,t,r)=>friendlyJSONstringify({l:e,k:t,s:r}),friendlyJSONstringify=e=>JSON.stringify(e).replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029").replace(/\u0027/g,"\\u0027"),isNumber=e=>"number"==typeof e&&isFinite(e),isDate=e=>"[object Date]"===toTypeString(e),isRegExp=e=>"[object RegExp]"===toTypeString(e),isEmptyObject=e=>isPlainObject(e)&&0===Object.keys(e).length,assign=Object.assign,_create=Object.create,create=(e=null)=>_create(e);function escapeHtml(e){return e.replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&apos;")}const hasOwnProperty=Object.prototype.hasOwnProperty;function hasOwn(e,t){return hasOwnProperty.call(e,t)}const isArray=Array.isArray,isFunction=e=>"function"==typeof e,isString=e=>"string"==typeof e,isBoolean=e=>"boolean"==typeof e,isObject=e=>null!==e&&"object"==typeof e,isPromise=e=>isObject(e)&&isFunction(e.then)&&isFunction(e.catch),objectToString=Object.prototype.toString,toTypeString=e=>objectToString.call(e),isPlainObject=e=>"[object Object]"===toTypeString(e),toDisplayString=e=>null==e?"":isArray(e)||isPlainObject(e)&&e.toString===objectToString?JSON.stringify(e,null,2):String(e);function join(e,t=""){return e.reduce(((e,r,n)=>0===n?e+r:e+t+r),"")}function warn(e,t){"undefined"!=typeof console&&(console.warn("[intlify] "+e),t&&console.warn(t.stack))}const isNotObjectOrIsArray=e=>!isObject(e)||isArray(e);function deepCopy(e,t){if(isNotObjectOrIsArray(e)||isNotObjectOrIsArray(t))throw new Error("Invalid value");const r=[{src:e,des:t}];for(;r.length;){const{src:e,des:t}=r.pop();Object.keys(e).forEach((n=>{"__proto__"!==n&&(isObject(e[n])&&!isObject(t[n])&&(t[n]=Array.isArray(e[n])?[]:create()),isNotObjectOrIsArray(t[n])||isNotObjectOrIsArray(e[n])?t[n]=e[n]:r.push({src:e[n],des:t[n]}))}))}}function createPosition(e,t,r){return{line:e,column:t,offset:r}}function createLocation(e,t,r){return{start:e,end:t}}const CompileErrorCodes={EXPECTED_TOKEN:1,INVALID_TOKEN_IN_PLACEHOLDER:2,UNTERMINATED_SINGLE_QUOTE_IN_PLACEHOLDER:3,UNKNOWN_ESCAPE_SEQUENCE:4,INVALID_UNICODE_ESCAPE_SEQUENCE:5,UNBALANCED_CLOSING_BRACE:6,UNTERMINATED_CLOSING_BRACE:7,EMPTY_PLACEHOLDER:8,NOT_ALLOW_NEST_PLACEHOLDER:9,INVALID_LINKED_FORMAT:10,MUST_HAVE_MESSAGES_IN_PLURAL:11,UNEXPECTED_EMPTY_LINKED_MODIFIER:12,UNEXPECTED_EMPTY_LINKED_KEY:13,UNEXPECTED_LEXICAL_ANALYSIS:14,UNHANDLED_CODEGEN_NODE_TYPE:15,UNHANDLED_MINIFIER_NODE_TYPE:16},COMPILE_ERROR_CODES_EXTEND_POINT=17;function createCompileError(e,t,r={}){const{domain:n,messages:o,args:a}=r,s=new SyntaxError(String(e));return s.code=e,t&&(s.location=t),s.domain=n,s}function defaultOnError(e){throw e}function mangle(e){switch(e.t=e.type,e.type){case 0:{const t=e;mangle(t.body),t.b=t.body,delete t.body;break}case 1:{const t=e,r=t.cases;for(let e=0;e<r.length;e++)mangle(r[e]);t.c=r,delete t.cases;break}case 2:{const t=e,r=t.items;for(let e=0;e<r.length;e++)mangle(r[e]);t.i=r,delete t.items,t.static&&(t.s=t.static,delete t.static);break}case 3:case 9:case 8:case 7:{const t=e;t.value&&(t.v=t.value,delete t.value);break}case 6:{const t=e;mangle(t.key),t.k=t.key,delete t.key,t.modifier&&(mangle(t.modifier),t.m=t.modifier,delete t.modifier);break}case 5:{const t=e;t.i=t.index,delete t.index;break}case 4:{const t=e;t.k=t.key,delete t.key;break}}delete e.type}function optimize(e){const t=e.body;return 2===t.type?optimizeMessageNode(t):t.cases.forEach((e=>optimizeMessageNode(e))),e}function optimizeMessageNode(e){if(1===e.items.length){const t=e.items[0];3!==t.type&&9!==t.type||(e.static=t.value,delete t.value)}else{const t=[];for(let r=0;r<e.items.length;r++){const n=e.items[r];if(3!==n.type&&9!==n.type)break;if(null==n.value)break;t.push(n.value)}if(t.length===e.items.length){e.static=join(t);for(let t=0;t<e.items.length;t++){const r=e.items[t];3!==r.type&&9!==r.type||delete r.value}}}}const CHAR_SP=" ",CHAR_CR="\r",CHAR_LF="\n",CHAR_LS=String.fromCharCode(8232),CHAR_PS=String.fromCharCode(8233);function createScanner(e){const t=e;let r=0,n=1,o=1,a=0;const s=e=>t[e]===CHAR_CR&&t[e+1]===CHAR_LF,l=e=>t[e]===CHAR_PS,i=e=>t[e]===CHAR_LS,c=e=>s(e)||(e=>t[e]===CHAR_LF)(e)||l(e)||i(e),u=e=>s(e)||l(e)||i(e)?CHAR_LF:t[e];function m(){return a=0,c(r)&&(n++,o=0),s(r)&&r++,r++,o++,t[r]}return{index:()=>r,line:()=>n,column:()=>o,peekOffset:()=>a,charAt:u,currentChar:()=>u(r),currentPeek:()=>u(r+a),next:m,peek:function(){return s(r+a)&&a++,a++,t[r+a]},reset:function(){r=0,n=1,o=1,a=0},resetPeek:function(e=0){a=e},skipToPeek:function(){const e=r+a;for(;e!==r;)m();a=0}}}const EOF=void 0,DOT=".",LITERAL_DELIMITER="'",ERROR_DOMAIN$1="tokenizer";function createTokenizer(e,t={}){const r=!1!==t.location,n=createScanner(e),o=()=>n.index(),a=()=>createPosition(n.line(),n.column(),n.index()),s=a(),l=o(),i={currentType:13,offset:l,startLoc:s,endLoc:s,lastType:13,lastOffset:l,lastStartLoc:s,lastEndLoc:s,braceNest:0,inLinked:!1,text:""},c=()=>i,{onError:u}=t;function m(e,t,n){e.endLoc=a(),e.currentType=t;const o={type:t};return r&&(o.loc=createLocation(e.startLoc,e.endLoc)),null!=n&&(o.value=n),o}const f=e=>m(e,13);function p(e,t){return e.currentChar()===t?(e.next(),t):(CompileErrorCodes.EXPECTED_TOKEN,a(),"")}function E(e){let t="";for(;e.currentPeek()===CHAR_SP||e.currentPeek()===CHAR_LF;)t+=e.currentPeek(),e.peek();return t}function _(e){const t=E(e);return e.skipToPeek(),t}function g(e){if(e===EOF)return!1;const t=e.charCodeAt(0);return t>=97&&t<=122||t>=65&&t<=90||95===t}function d(e,t){const{currentType:r}=t;if(2!==r)return!1;E(e);const n=function(e){if(e===EOF)return!1;const t=e.charCodeAt(0);return t>=48&&t<=57}("-"===e.currentPeek()?e.peek():e.currentPeek());return e.resetPeek(),n}function b(e){E(e);const t="|"===e.currentPeek();return e.resetPeek(),t}function C(e,t=!0){const r=(t=!1,n="")=>{const o=e.currentPeek();return"{"===o?t:"@"!==o&&o?"|"===o?!(n===CHAR_SP||n===CHAR_LF):o===CHAR_SP?(e.peek(),r(!0,CHAR_SP)):o!==CHAR_LF||(e.peek(),r(!0,CHAR_LF)):t},n=r();return t&&e.resetPeek(),n}function O(e,t){const r=e.currentChar();return r===EOF?EOF:t(r)?(e.next(),r):null}function S(e){const t=e.charCodeAt(0);return t>=97&&t<=122||t>=65&&t<=90||t>=48&&t<=57||95===t||36===t}function T(e){return O(e,S)}function L(e){const t=e.charCodeAt(0);return t>=97&&t<=122||t>=65&&t<=90||t>=48&&t<=57||95===t||36===t||45===t}function N(e){return O(e,L)}function A(e){const t=e.charCodeAt(0);return t>=48&&t<=57}function P(e){return O(e,A)}function y(e){const t=e.charCodeAt(0);return t>=48&&t<=57||t>=65&&t<=70||t>=97&&t<=102}function h(e){return O(e,y)}function k(e){let t="",r="";for(;t=P(e);)r+=t;return r}function I(e){return e!==LITERAL_DELIMITER&&e!==CHAR_LF}function R(e){const t=e.currentChar();switch(t){case"\\":case"'":return e.next(),`\\${t}`;case"u":return F(e,t,4);case"U":return F(e,t,6);default:return CompileErrorCodes.UNKNOWN_ESCAPE_SEQUENCE,a(),""}}function F(e,t,r){p(e,t);let n="";for(let o=0;o<r;o++){const t=h(e);if(!t){CompileErrorCodes.INVALID_UNICODE_ESCAPE_SEQUENCE,a(),e.currentChar();break}n+=t}return`\\${t}${n}`}function v(e){return"{"!==e&&"}"!==e&&e!==CHAR_SP&&e!==CHAR_LF}function D(e){_(e);const t=p(e,"|");return _(e),t}function M(e,t){let r=null;switch(e.currentChar()){case"{":return t.braceNest>=1&&(CompileErrorCodes.NOT_ALLOW_NEST_PLACEHOLDER,a()),e.next(),r=m(t,2,"{"),_(e),t.braceNest++,r;case"}":return t.braceNest>0&&2===t.currentType&&(CompileErrorCodes.EMPTY_PLACEHOLDER,a()),e.next(),r=m(t,3,"}"),t.braceNest--,t.braceNest>0&&_(e),t.inLinked&&0===t.braceNest&&(t.inLinked=!1),r;case"@":return t.braceNest>0&&(CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,a()),r=U(e,t)||f(t),t.braceNest=0,r;default:{let n=!0,o=!0,s=!0;if(b(e))return t.braceNest>0&&(CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,a()),r=m(t,1,D(e)),t.braceNest=0,t.inLinked=!1,r;if(t.braceNest>0&&(4===t.currentType||5===t.currentType||6===t.currentType))return CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,a(),t.braceNest=0,j(e,t);if(n=function(e,t){const{currentType:r}=t;if(2!==r)return!1;E(e);const n=g(e.currentPeek());return e.resetPeek(),n}(e,t))return r=m(t,4,function(e){_(e);let t="",r="";for(;t=N(e);)r+=t;return e.currentChar()===EOF&&(CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,a()),r}(e)),_(e),r;if(o=d(e,t))return r=m(t,5,function(e){_(e);let t="";return"-"===e.currentChar()?(e.next(),t+=`-${k(e)}`):t+=k(e),e.currentChar()===EOF&&(CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,a()),t}(e)),_(e),r;if(s=function(e,t){const{currentType:r}=t;if(2!==r)return!1;E(e);const n=e.currentPeek()===LITERAL_DELIMITER;return e.resetPeek(),n}(e,t))return r=m(t,6,function(e){_(e),p(e,"'");let t="",r="";for(;t=O(e,I);)r+="\\"===t?R(e):t;const n=e.currentChar();return n===CHAR_LF||n===EOF?(CompileErrorCodes.UNTERMINATED_SINGLE_QUOTE_IN_PLACEHOLDER,a(),n===CHAR_LF&&(e.next(),p(e,"'")),r):(p(e,"'"),r)}(e)),_(e),r;if(!n&&!o&&!s)return r=m(t,12,function(e){_(e);let t="",r="";for(;t=O(e,v);)r+=t;return r}(e)),CompileErrorCodes.INVALID_TOKEN_IN_PLACEHOLDER,a(),r.value,_(e),r;break}}return r}function U(e,t){const{currentType:r}=t;let n=null;const o=e.currentChar();switch(7!==r&&8!==r&&11!==r&&9!==r||o!==CHAR_LF&&o!==CHAR_SP||(CompileErrorCodes.INVALID_LINKED_FORMAT,a()),o){case"@":return e.next(),n=m(t,7,"@"),t.inLinked=!0,n;case".":return _(e),e.next(),m(t,8,".");case":":return _(e),e.next(),m(t,9,":");default:return b(e)?(n=m(t,1,D(e)),t.braceNest=0,t.inLinked=!1,n):function(e,t){const{currentType:r}=t;if(7!==r)return!1;E(e);const n="."===e.currentPeek();return e.resetPeek(),n}(e,t)||function(e,t){const{currentType:r}=t;if(7!==r&&11!==r)return!1;E(e);const n=":"===e.currentPeek();return e.resetPeek(),n}(e,t)?(_(e),U(e,t)):function(e,t){const{currentType:r}=t;if(8!==r)return!1;E(e);const n=g(e.currentPeek());return e.resetPeek(),n}(e,t)?(_(e),m(t,11,function(e){let t="",r="";for(;t=T(e);)r+=t;return r}(e))):function(e,t){const{currentType:r}=t;if(9!==r)return!1;const n=()=>{const t=e.currentPeek();return"{"===t?g(e.peek()):!("@"===t||"|"===t||":"===t||"."===t||t===CHAR_SP||!t)&&(t===CHAR_LF?(e.peek(),n()):C(e,!1))},o=n();return e.resetPeek(),o}(e,t)?(_(e),"{"===o?M(e,t)||n:m(t,10,function(e){const t=r=>{const n=e.currentChar();return"{"!==n&&"@"!==n&&"|"!==n&&"("!==n&&")"!==n&&n?n===CHAR_SP?r:(r+=n,e.next(),t(r)):r};return t("")}(e))):(7===r&&(CompileErrorCodes.INVALID_LINKED_FORMAT,a()),t.braceNest=0,t.inLinked=!1,j(e,t))}}function j(e,t){let r={type:13};if(t.braceNest>0)return M(e,t)||f(t);if(t.inLinked)return U(e,t)||f(t);switch(e.currentChar()){case"{":return M(e,t)||f(t);case"}":return CompileErrorCodes.UNBALANCED_CLOSING_BRACE,a(),e.next(),m(t,3,"}");case"@":return U(e,t)||f(t);default:if(b(e))return r=m(t,1,D(e)),t.braceNest=0,t.inLinked=!1,r;if(C(e))return m(t,0,function(e){let t="";for(;;){const r=e.currentChar();if("{"===r||"}"===r||"@"===r||"|"===r||!r)break;if(r===CHAR_SP||r===CHAR_LF)if(C(e))t+=r,e.next();else{if(b(e))break;t+=r,e.next()}else t+=r,e.next()}return t}(e))}return r}return{nextToken:function(){const{currentType:e,offset:t,startLoc:r,endLoc:s}=i;return i.lastType=e,i.lastOffset=t,i.lastStartLoc=r,i.lastEndLoc=s,i.offset=o(),i.startLoc=a(),n.currentChar()===EOF?m(i,13):j(n,i)},currentOffset:o,currentPosition:a,context:c}}const ERROR_DOMAIN="parser",KNOWN_ESCAPES=/(?:\\\\|\\'|\\u([0-9a-fA-F]{4})|\\U([0-9a-fA-F]{6}))/g;function fromEscapeSequence(e,t,r){switch(e){case"\\\\":return"\\";case"\\'":return"'";default:{const e=parseInt(t||r,16);return e<=55295||e>=57344?String.fromCodePoint(e):"�"}}}function createParser(e={}){const t=!1!==e.location,{onError:r}=e;function n(e,r,n){const o={type:e};return t&&(o.start=r,o.end=r,o.loc={start:n,end:n}),o}function o(e,r,n,o){t&&(e.end=r,e.loc&&(e.loc.end=n))}function a(e,t){const r=e.context(),a=n(3,r.offset,r.startLoc);return a.value=t,o(a,e.currentOffset(),e.currentPosition()),a}function s(e,t){const r=e.context(),{lastOffset:a,lastStartLoc:s}=r,l=n(5,a,s);return l.index=parseInt(t,10),e.nextToken(),o(l,e.currentOffset(),e.currentPosition()),l}function l(e,t){const r=e.context(),{lastOffset:a,lastStartLoc:s}=r,l=n(4,a,s);return l.key=t,e.nextToken(),o(l,e.currentOffset(),e.currentPosition()),l}function i(e,t){const r=e.context(),{lastOffset:a,lastStartLoc:s}=r,l=n(9,a,s);return l.value=t.replace(KNOWN_ESCAPES,fromEscapeSequence),e.nextToken(),o(l,e.currentOffset(),e.currentPosition()),l}function c(e){const t=e.context(),r=n(6,t.offset,t.startLoc);let a=e.nextToken();if(8===a.type){const t=function(e){const t=e.nextToken(),r=e.context(),{lastOffset:a,lastStartLoc:s}=r,l=n(8,a,s);return 11!==t.type?(CompileErrorCodes.UNEXPECTED_EMPTY_LINKED_MODIFIER,r.lastStartLoc,l.value="",o(l,a,s),{nextConsumeToken:t,node:l}):(null==t.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,r.lastStartLoc,getTokenCaption(t)),l.value=t.value||"",o(l,e.currentOffset(),e.currentPosition()),{node:l})}(e);r.modifier=t.node,a=t.nextConsumeToken||e.nextToken()}switch(9!==a.type&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),a=e.nextToken(),2===a.type&&(a=e.nextToken()),a.type){case 10:null==a.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),r.key=function(e,t){const r=e.context(),a=n(7,r.offset,r.startLoc);return a.value=t,o(a,e.currentOffset(),e.currentPosition()),a}(e,a.value||"");break;case 4:null==a.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),r.key=l(e,a.value||"");break;case 5:null==a.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),r.key=s(e,a.value||"");break;case 6:null==a.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),r.key=i(e,a.value||"");break;default:{CompileErrorCodes.UNEXPECTED_EMPTY_LINKED_KEY,t.lastStartLoc;const s=e.context(),l=n(7,s.offset,s.startLoc);return l.value="",o(l,s.offset,s.startLoc),r.key=l,o(r,s.offset,s.startLoc),{nextConsumeToken:a,node:r}}}return o(r,e.currentOffset(),e.currentPosition()),{node:r}}function u(e){const t=e.context(),r=n(2,1===t.currentType?e.currentOffset():t.offset,1===t.currentType?t.endLoc:t.startLoc);r.items=[];let u=null;do{const n=u||e.nextToken();switch(u=null,n.type){case 0:null==n.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(n)),r.items.push(a(e,n.value||""));break;case 5:null==n.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(n)),r.items.push(s(e,n.value||""));break;case 4:null==n.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(n)),r.items.push(l(e,n.value||""));break;case 6:null==n.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(n)),r.items.push(i(e,n.value||""));break;case 7:{const t=c(e);r.items.push(t.node),u=t.nextConsumeToken||null;break}}}while(13!==t.currentType&&1!==t.currentType);return o(r,1===t.currentType?t.lastOffset:e.currentOffset(),1===t.currentType?t.lastEndLoc:e.currentPosition()),r}function m(e){const t=e.context(),{offset:r,startLoc:a}=t,s=u(e);return 13===t.currentType?s:function(e,t,r,a){const s=e.context();let l=0===a.items.length;const i=n(1,t,r);i.cases=[],i.cases.push(a);do{const t=u(e);l||(l=0===t.items.length),i.cases.push(t)}while(13!==s.currentType);return o(i,e.currentOffset(),e.currentPosition()),i}(e,r,a,s)}return{parse:function(r){const a=createTokenizer(r,assign({},e)),s=a.context(),l=n(0,s.offset,s.startLoc);return t&&l.loc&&(l.loc.source=r),l.body=m(a),e.onCacheKey&&(l.cacheKey=e.onCacheKey(r)),13!==s.currentType&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,s.lastStartLoc,r[s.offset]),o(l,a.currentOffset(),a.currentPosition()),l}}}function getTokenCaption(e){if(13===e.type)return"EOF";const t=(e.value||"").replace(/\r?\n/gu,"\\n");return t.length>10?t.slice(0,9)+"…":t}function format(e){return t=>formatParts(t,e)}function formatParts(e,t){const r=resolveBody(t);if(null==r)throw createUnhandleNodeError(0);if(1===resolveType(r)){const t=resolveCases(r);return e.plural(t.reduce(((t,r)=>[...t,formatMessageParts(e,r)]),[]))}return formatMessageParts(e,r)}const PROPS_BODY=["b","body"];function resolveBody(e){return resolveProps(e,PROPS_BODY)}const PROPS_CASES=["c","cases"];function resolveCases(e){return resolveProps(e,PROPS_CASES,[])}function formatMessageParts(e,t){const r=resolveStatic(t);if(null!=r)return"text"===e.type?r:e.normalize([r]);{const r=resolveItems(t).reduce(((t,r)=>[...t,formatMessagePart(e,r)]),[]);return e.normalize(r)}}const PROPS_STATIC=["s","static"];function resolveStatic(e){return resolveProps(e,PROPS_STATIC)}const PROPS_ITEMS=["i","items"];function resolveItems(e){return resolveProps(e,PROPS_ITEMS,[])}function formatMessagePart(e,t){const r=resolveType(t);switch(r){case 3:case 9:case 7:case 8:return resolveValue$1(t,r);case 4:{const n=t;if(hasOwn(n,"k")&&n.k)return e.interpolate(e.named(n.k));if(hasOwn(n,"key")&&n.key)return e.interpolate(e.named(n.key));throw createUnhandleNodeError(r)}case 5:{const n=t;if(hasOwn(n,"i")&&isNumber(n.i))return e.interpolate(e.list(n.i));if(hasOwn(n,"index")&&isNumber(n.index))return e.interpolate(e.list(n.index));throw createUnhandleNodeError(r)}case 6:{const r=t,n=resolveLinkedModifier(r),o=resolveLinkedKey(r);return e.linked(formatMessagePart(e,o),n?formatMessagePart(e,n):void 0,e.type)}default:throw new Error(`unhandled node on format message part: ${r}`)}}const PROPS_TYPE=["t","type"];function resolveType(e){return resolveProps(e,PROPS_TYPE)}const PROPS_VALUE=["v","value"];function resolveValue$1(e,t){const r=resolveProps(e,PROPS_VALUE);if(null!=r)return r;throw createUnhandleNodeError(t)}const PROPS_MODIFIER=["m","modifier"];function resolveLinkedModifier(e){return resolveProps(e,PROPS_MODIFIER)}const PROPS_KEY=["k","key"];function resolveLinkedKey(e){const t=resolveProps(e,PROPS_KEY);if(t)return t;throw createUnhandleNodeError(6)}function resolveProps(e,t,r){for(let n=0;n<t.length;n++){const r=t[n];if(hasOwn(e,r)&&null!=e[r])return e[r]}return r}function createUnhandleNodeError(e){return new Error(`unhandled node type: ${e}`)}const defaultOnCacheKey=e=>e;let compileCache=create();function isMessageAST(e){return isObject(e)&&0===resolveType(e)&&(hasOwn(e,"b")||hasOwn(e,"body"))}function baseCompile(e,t={}){let r=!1;const n=t.onError||defaultOnError;t.onError=e=>{r=!0,n(e)};const o=createParser(t).parse(e);return t.optimize&&optimize(o),t.mangle&&mangle(o),{ast:o,detectError:r,code:""}}function compile(e,t){if(isString(e)){!isBoolean(t.warnHtmlMessage)||t.warnHtmlMessage;const r=(t.onCacheKey||defaultOnCacheKey)(e),n=compileCache[r];if(n)return n;const{ast:o,detectError:a}=baseCompile(e,{...t,location:!1,mangle:!0,optimize:!0}),s=format(o);return a?s:compileCache[r]=s}{const t=e.cacheKey;if(t){const r=compileCache[t];return r||(compileCache[t]=format(e))}return format(e)}}const CoreErrorCodes={INVALID_ARGUMENT:17,INVALID_DATE_ARGUMENT:18,INVALID_ISO_DATE_ARGUMENT:19,NOT_SUPPORT_NON_STRING_MESSAGE:20,NOT_SUPPORT_LOCALE_PROMISE_VALUE:21,NOT_SUPPORT_LOCALE_ASYNC_FUNCTION:22,NOT_SUPPORT_LOCALE_TYPE:23},CORE_ERROR_CODES_EXTEND_POINT=24;function getLocale(e,t){return null!=t.locale?resolveLocale(t.locale):resolveLocale(e.locale)}let _resolveLocale;function resolveLocale(e){if(isString(e))return e;if(isFunction(e)){if(e.resolvedOnce&&null!=_resolveLocale)return _resolveLocale;if("Function"===e.constructor.name){const t=e();if(isPromise(t))throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_PROMISE_VALUE);return _resolveLocale=t}throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_ASYNC_FUNCTION)}throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_TYPE)}function fallbackWithSimple(e,t,r){return[...new Set([r,...isArray(t)?t:isObject(t)?Object.keys(t):isString(t)?[t]:[r]])]}function fallbackWithLocaleChain(e,t,r){const n=isString(r)?r:DEFAULT_LOCALE,o=e;o.__localeChainCache||(o.__localeChainCache=new Map);let a=o.__localeChainCache.get(n);if(!a){a=[];let e=[r];for(;isArray(e);)e=appendBlockToChain(a,e,t);const s=isArray(t)||!isPlainObject(t)?t:t.default?t.default:null;e=isString(s)?[s]:s,isArray(e)&&appendBlockToChain(a,e,!1),o.__localeChainCache.set(n,a)}return a}function appendBlockToChain(e,t,r){let n=!0;for(let o=0;o<t.length&&isBoolean(n);o++){const a=t[o];isString(a)&&(n=appendLocaleToChain(e,t[o],r))}return n}function appendLocaleToChain(e,t,r){let n;const o=t.split("-");do{n=appendItemToChain(e,o.join("-"),r),o.splice(-1,1)}while(o.length&&!0===n);return n}function appendItemToChain(e,t,r){let n=!1;if(!e.includes(t)&&(n=!0,t)){n="!"!==t[t.length-1];const o=t.replace(/!/g,"");e.push(o),(isArray(r)||isPlainObject(r))&&r[o]&&(n=r[o])}return n}const pathStateMachine=[];pathStateMachine[0]={w:[0],i:[3,0],"[":[4],o:[7]},pathStateMachine[1]={w:[1],".":[2],"[":[4],o:[7]},pathStateMachine[2]={w:[2],i:[3,0],0:[3,0]},pathStateMachine[3]={i:[3,0],0:[3,0],w:[1,1],".":[2,1],"[":[4,1],o:[7,1]},pathStateMachine[4]={"'":[5,0],'"':[6,0],"[":[4,2],"]":[1,3],o:8,l:[4,0]},pathStateMachine[5]={"'":[4,0],o:8,l:[5,0]},pathStateMachine[6]={'"':[4,0],o:8,l:[6,0]};const literalValueRE=/^\s?(?:true|false|-?[\d.]+|'[^']*'|"[^"]*")\s?$/;function isLiteral(e){return literalValueRE.test(e)}function stripQuotes(e){const t=e.charCodeAt(0);return t!==e.charCodeAt(e.length-1)||34!==t&&39!==t?e:e.slice(1,-1)}function getPathCharType(e){if(null==e)return"o";switch(e.charCodeAt(0)){case 91:case 93:case 46:case 34:case 39:return e;case 95:case 36:case 45:return"i";case 9:case 10:case 13:case 160:case 65279:case 8232:case 8233:return"w"}return"i"}function formatSubPath(e){const t=e.trim();return("0"!==e.charAt(0)||!isNaN(parseInt(e)))&&(isLiteral(t)?stripQuotes(t):"*"+t)}function parse(e){const t=[];let r,n,o,a,s,l,i,c=-1,u=0,m=0;const f=[];function p(){const t=e[c+1];if(5===u&&"'"===t||6===u&&'"'===t)return c++,o="\\"+t,f[0](),!0}for(f[0]=()=>{void 0===n?n=o:n+=o},f[1]=()=>{void 0!==n&&(t.push(n),n=void 0)},f[2]=()=>{f[0](),m++},f[3]=()=>{if(m>0)m--,u=4,f[0]();else{if(m=0,void 0===n)return!1;if(n=formatSubPath(n),!1===n)return!1;f[1]()}};null!==u;)if(c++,r=e[c],"\\"!==r||!p()){if(a=getPathCharType(r),i=pathStateMachine[u],s=i[a]||i.l||8,8===s)return;if(u=s[0],void 0!==s[1]&&(l=f[s[1]],l&&(o=r,!1===l())))return;if(7===u)return t}}const cache=new Map;function resolveWithKeyValue(e,t){return isObject(e)?e[t]:null}function resolveValue(e,t){if(!isObject(e))return null;let r=cache.get(t);if(r||(r=parse(t),r&&cache.set(t,r)),!r)return null;const n=r.length;let o=e,a=0;for(;a<n;){const e=o[r[a]];if(void 0===e)return null;if(isFunction(o))return null;o=e,a++}return o}const VERSION$1="12.0.0-alpha.2",NOT_REOSLVED=-1,DEFAULT_LOCALE="en-US",MISSING_RESOLVE_VALUE="",capitalize=e=>`${e.charAt(0).toLocaleUpperCase()}${e.substr(1)}`;function getDefaultLinkedModifiers(){return{upper:(e,t)=>"text"===t&&isString(e)?e.toUpperCase():"vnode"===t&&isObject(e)&&"__v_isVNode"in e?e.children.toUpperCase():e,lower:(e,t)=>"text"===t&&isString(e)?e.toLowerCase():"vnode"===t&&isObject(e)&&"__v_isVNode"in e?e.children.toLowerCase():e,capitalize:(e,t)=>"text"===t&&isString(e)?capitalize(e):"vnode"===t&&isObject(e)&&"__v_isVNode"in e?capitalize(e.children):e}}let _compiler,_resolver,_fallbacker;function registerMessageCompiler(e){_compiler=e}function registerMessageResolver(e){_resolver=e}function registerLocaleFallbacker(e){_fallbacker=e}const setAdditionalMeta=e=>{};let _fallbackContext=null;const setFallbackContext=e=>{_fallbackContext=e},getFallbackContext=()=>_fallbackContext;let _cid=0;function createCoreContext(e={}){const t=isFunction(e.onWarn)?e.onWarn:warn,r=isString(e.version)?e.version:VERSION$1,n=isString(e.locale)||isFunction(e.locale)?e.locale:DEFAULT_LOCALE,o=isFunction(n)?DEFAULT_LOCALE:n,a=isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||isString(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:o,s=isPlainObject(e.messages)?e.messages:createResources(o),l=isPlainObject(e.datetimeFormats)?e.datetimeFormats:createResources(o),i=isPlainObject(e.numberFormats)?e.numberFormats:createResources(o),c=assign(create(),e.modifiers,getDefaultLinkedModifiers()),u=e.pluralRules||create(),m=isFunction(e.missing)?e.missing:null,f=!isBoolean(e.missingWarn)&&!isRegExp(e.missingWarn)||e.missingWarn,p=!isBoolean(e.fallbackWarn)&&!isRegExp(e.fallbackWarn)||e.fallbackWarn,E=!!e.fallbackFormat,_=!!e.unresolving,g=isFunction(e.postTranslation)?e.postTranslation:null,d=isPlainObject(e.processor)?e.processor:null,b=!isBoolean(e.warnHtmlMessage)||e.warnHtmlMessage,C=!!e.escapeParameter,O=isFunction(e.messageCompiler)?e.messageCompiler:_compiler,S=isFunction(e.messageResolver)?e.messageResolver:_resolver||resolveWithKeyValue,T=isFunction(e.localeFallbacker)?e.localeFallbacker:_fallbacker||fallbackWithSimple,L=isObject(e.fallbackContext)?e.fallbackContext:void 0,N=e,A=isObject(N.__datetimeFormatters)?N.__datetimeFormatters:new Map,P=isObject(N.__numberFormatters)?N.__numberFormatters:new Map,y=isObject(N.__meta)?N.__meta:{};_cid++;const h={version:r,cid:_cid,locale:n,fallbackLocale:a,messages:s,modifiers:c,pluralRules:u,missing:m,missingWarn:f,fallbackWarn:p,fallbackFormat:E,unresolving:_,postTranslation:g,processor:d,warnHtmlMessage:b,escapeParameter:C,messageCompiler:O,messageResolver:S,localeFallbacker:T,fallbackContext:L,onWarn:t,__meta:y};return h.datetimeFormats=l,h.numberFormats=i,h.__datetimeFormatters=A,h.__numberFormatters=P,h}const createResources=e=>({[e]:create()});function handleMissing(e,t,r,n,o){const{missing:a,onWarn:s}=e;if(null!==a){const n=a(e,r,t,o);return isString(n)?n:t}return t}function updateFallbackLocale(e,t,r){e.__localeChainCache=new Map,e.localeFallbacker(e,r,t)}function isAlmostSameLocale(e,t){return e!==t&&e.split("-")[0]===t.split("-")[0]}function isImplicitFallback(e,t){const r=t.indexOf(e);if(-1===r)return!1;for(let n=r+1;n<t.length;n++)if(isAlmostSameLocale(e,t[n]))return!0;return!1}function datetime(e,...t){const{datetimeFormats:r,unresolving:n,fallbackLocale:o,onWarn:a,localeFallbacker:s}=e,{__datetimeFormatters:l}=e,[i,c,u,m]=parseDateTimeArgs(...t),f=isBoolean(u.missingWarn)?u.missingWarn:e.missingWarn;isBoolean(u.fallbackWarn)?u.fallbackWarn:e.fallbackWarn;const p=!!u.part,E=getLocale(e,u),_=s(e,o,E);if(!isString(i)||""===i)return new Intl.DateTimeFormat(E,m).format(c);let g,d={},b=null;for(let S=0;S<_.length&&(g=_[S],d=r[g]||{},b=d[i],!isPlainObject(b));S++)handleMissing(e,i,g,f,"datetime format");if(!isPlainObject(b)||!isString(g))return n?NOT_REOSLVED:i;let C=`${g}__${i}`;isEmptyObject(m)||(C=`${C}__${JSON.stringify(m)}`);let O=l.get(C);return O||(O=new Intl.DateTimeFormat(g,assign({},b,m)),l.set(C,O)),p?O.formatToParts(c):O.format(c)}const DATETIME_FORMAT_OPTIONS_KEYS=["localeMatcher","weekday","era","year","month","day","hour","minute","second","timeZoneName","formatMatcher","hour12","timeZone","dateStyle","timeStyle","calendar","dayPeriod","numberingSystem","hourCycle","fractionalSecondDigits"];function parseDateTimeArgs(...e){const[t,r,n,o]=e,a=create();let s,l=create();if(isString(t)){const e=t.match(/(\d{4}-\d{2}-\d{2})(T|\s)?(.*)/);if(!e)throw Error(CoreErrorCodes.INVALID_ISO_DATE_ARGUMENT);const r=e[3]?e[3].trim().startsWith("T")?`${e[1].trim()}${e[3].trim()}`:`${e[1].trim()}T${e[3].trim()}`:e[1].trim();s=new Date(r);try{s.toISOString()}catch{throw Error(CoreErrorCodes.INVALID_ISO_DATE_ARGUMENT)}}else if(isDate(t)){if(isNaN(t.getTime()))throw Error(CoreErrorCodes.INVALID_DATE_ARGUMENT);s=t}else{if(!isNumber(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);s=t}return isString(r)?a.key=r:isPlainObject(r)&&Object.keys(r).forEach((e=>{DATETIME_FORMAT_OPTIONS_KEYS.includes(e)?l[e]=r[e]:a[e]=r[e]})),isString(n)?a.locale=n:isPlainObject(n)&&(l=n),isPlainObject(o)&&(l=o),[a.key||"",s,a,l]}function clearDateTimeFormat(e,t,r){const n=e;for(const o in r){const e=`${t}__${o}`;n.__datetimeFormatters.has(e)&&n.__datetimeFormatters.delete(e)}}function number(e,...t){const{numberFormats:r,unresolving:n,fallbackLocale:o,onWarn:a,localeFallbacker:s}=e,{__numberFormatters:l}=e,[i,c,u,m]=parseNumberArgs(...t),f=isBoolean(u.missingWarn)?u.missingWarn:e.missingWarn;isBoolean(u.fallbackWarn)?u.fallbackWarn:e.fallbackWarn;const p=!!u.part,E=getLocale(e,u),_=s(e,o,E);if(!isString(i)||""===i)return new Intl.NumberFormat(E,m).format(c);let g,d={},b=null;for(let S=0;S<_.length&&(g=_[S],d=r[g]||{},b=d[i],!isPlainObject(b));S++)handleMissing(e,i,g,f,"number format");if(!isPlainObject(b)||!isString(g))return n?NOT_REOSLVED:i;let C=`${g}__${i}`;isEmptyObject(m)||(C=`${C}__${JSON.stringify(m)}`);let O=l.get(C);return O||(O=new Intl.NumberFormat(g,assign({},b,m)),l.set(C,O)),p?O.formatToParts(c):O.format(c)}const NUMBER_FORMAT_OPTIONS_KEYS=["localeMatcher","style","currency","currencyDisplay","currencySign","useGrouping","minimumIntegerDigits","minimumFractionDigits","maximumFractionDigits","minimumSignificantDigits","maximumSignificantDigits","compactDisplay","notation","signDisplay","unit","unitDisplay","roundingMode","roundingPriority","roundingIncrement","trailingZeroDisplay"];function parseNumberArgs(...e){const[t,r,n,o]=e,a=create();let s=create();if(!isNumber(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);const l=t;return isString(r)?a.key=r:isPlainObject(r)&&Object.keys(r).forEach((e=>{NUMBER_FORMAT_OPTIONS_KEYS.includes(e)?s[e]=r[e]:a[e]=r[e]})),isString(n)?a.locale=n:isPlainObject(n)&&(s=n),isPlainObject(o)&&(s=o),[a.key||"",l,a,s]}function clearNumberFormat(e,t,r){const n=e;for(const o in r){const e=`${t}__${o}`;n.__numberFormatters.has(e)&&n.__numberFormatters.delete(e)}}const DEFAULT_MODIFIER=e=>e,DEFAULT_MESSAGE=e=>"",DEFAULT_MESSAGE_DATA_TYPE="text",DEFAULT_NORMALIZE=e=>0===e.length?"":join(e),DEFAULT_INTERPOLATE=toDisplayString;function pluralDefault(e,t){return e=Math.abs(e),2===t?e?e>1?1:0:1:e?Math.min(e,2):0}function getPluralIndex(e){const t=isNumber(e.pluralIndex)?e.pluralIndex:-1;return e.named&&(isNumber(e.named.count)||isNumber(e.named.n))?isNumber(e.named.count)?e.named.count:isNumber(e.named.n)?e.named.n:t:t}function normalizeNamed(e,t){t.count||(t.count=e),t.n||(t.n=e)}function createMessageContext(e={}){const t=e.locale,r=getPluralIndex(e),n=isObject(e.pluralRules)&&isString(t)&&isFunction(e.pluralRules[t])?e.pluralRules[t]:pluralDefault,o=isObject(e.pluralRules)&&isString(t)&&isFunction(e.pluralRules[t])?pluralDefault:void 0,a=e.list||[],s=e.named||create();isNumber(e.pluralIndex)&&normalizeNamed(r,s);function l(t,r){const n=isFunction(e.messages)?e.messages(t,!!r):!!isObject(e.messages)&&e.messages[t];return n||(e.parent?e.parent.message(t):DEFAULT_MESSAGE)}const i=isPlainObject(e.processor)&&isFunction(e.processor.normalize)?e.processor.normalize:DEFAULT_NORMALIZE,c=isPlainObject(e.processor)&&isFunction(e.processor.interpolate)?e.processor.interpolate:DEFAULT_INTERPOLATE,u={list:e=>a[e],named:e=>s[e],plural:e=>e[n(r,e.length,o)],linked:(t,...r)=>{const[n,o]=r;let a="text",s="";1===r.length?isObject(n)?(s=n.modifier||s,a=n.type||a):isString(n)&&(s=n||s):2===r.length&&(isString(n)&&(s=n||s),isString(o)&&(a=o||a));const i=l(t,!0)(u),c="vnode"===a&&isArray(i)&&s?i[0]:i;return s?(m=s,e.modifiers?e.modifiers[m]:DEFAULT_MODIFIER)(c,a):c;var m},message:l,type:isPlainObject(e.processor)&&isString(e.processor.type)?e.processor.type:DEFAULT_MESSAGE_DATA_TYPE,interpolate:c,normalize:i,values:assign(create(),a,s)};return u}const NOOP_MESSAGE_FUNCTION=()=>"",isMessageFunction=e=>isFunction(e);function translate(e,...t){const{fallbackFormat:r,postTranslation:n,unresolving:o,messageCompiler:a,fallbackLocale:s,messages:l}=e,[i,c]=parseTranslateArgs(...t),u=isBoolean(c.missingWarn)?c.missingWarn:e.missingWarn,m=isBoolean(c.fallbackWarn)?c.fallbackWarn:e.fallbackWarn,f=isBoolean(c.escapeParameter)?c.escapeParameter:e.escapeParameter,p=!!c.resolvedMessage,E=isString(c.default)||isBoolean(c.default)?isBoolean(c.default)?a?i:()=>i:c.default:r?a?i:()=>i:null,_=r||null!=E&&(isString(E)||isFunction(E)),g=getLocale(e,c);f&&escapeParams(c);let[d,b,C]=p?[i,g,l[g]||create()]:resolveMessageFormat(e,i,g,s,m,u),O=d,S=i;if(p||isString(O)||isMessageAST(O)||isMessageFunction(O)||_&&(O=E,S=O),!(p||(isString(O)||isMessageAST(O)||isMessageFunction(O))&&isString(b)))return o?NOT_REOSLVED:i;let T=!1;const L=isMessageFunction(O)?O:compileMessageFormat(e,i,b,O,S,(()=>{T=!0}));if(T)return O;const N=evaluateMessage(e,L,createMessageContext(getMessageContextOptions(e,b,C,c)));return n?n(N,i):N}function escapeParams(e){isArray(e.list)?e.list=e.list.map((e=>isString(e)?escapeHtml(e):e)):isObject(e.named)&&Object.keys(e.named).forEach((t=>{isString(e.named[t])&&(e.named[t]=escapeHtml(e.named[t]))}))}function resolveMessageFormat(e,t,r,n,o,a){const{messages:s,onWarn:l,messageResolver:i,localeFallbacker:c}=e,u=c(e,n,r);let m,f=create(),p=null;for(let E=0;E<u.length&&(m=u[E],f=s[m]||create(),null===(p=i(f,t))&&(p=f[t]),!(isString(p)||isMessageAST(p)||isMessageFunction(p)));E++)if(!isImplicitFallback(m,u)){const r=handleMissing(e,t,m,a,"translate");r!==t&&(p=r)}return[p,m,f]}function compileMessageFormat(e,t,r,n,o,a){const{messageCompiler:s,warnHtmlMessage:l}=e;if(isMessageFunction(n)){const e=n;return e.locale=e.locale||r,e.key=e.key||t,e}if(null==s){const e=()=>n;return e.locale=r,e.key=t,e}const i=s(n,getCompileContext(e,r,o,n,l,a));return i.locale=r,i.key=t,i.source=n,i}function evaluateMessage(e,t,r){return t(r)}function parseTranslateArgs(...e){const[t,r,n]=e,o=create();if(!(isString(t)||isNumber(t)||isMessageFunction(t)||isMessageAST(t)))throw Error(CoreErrorCodes.INVALID_ARGUMENT);const a=isNumber(t)?String(t):(isMessageFunction(t),t);return isNumber(r)?o.plural=r:isString(r)?o.default=r:isPlainObject(r)&&!isEmptyObject(r)?o.named=r:isArray(r)&&(o.list=r),isNumber(n)?o.plural=n:isString(n)?o.default=n:isPlainObject(n)&&assign(o,n),[a,o]}function getCompileContext(e,t,r,n,o,a){return{locale:t,key:r,warnHtmlMessage:o,onError:e=>{throw a&&a(e),e},onCacheKey:e=>generateFormatCacheKey(t,r,e)}}function getMessageContextOptions(e,t,r,n){const{modifiers:o,pluralRules:a,messageResolver:s,fallbackLocale:l,fallbackWarn:i,missingWarn:c,fallbackContext:u}=e,m={locale:t,modifiers:o,pluralRules:a,messages:(n,o)=>{let a=s(r,n);if(null==a&&(u||o)){const[,,r]=resolveMessageFormat(u||e,n,t,l,i,c);a=s(r,n)}if(isString(a)||isMessageAST(a)){let r=!1;const o=compileMessageFormat(e,n,t,a,n,(()=>{r=!0}));return r?NOOP_MESSAGE_FUNCTION:o}return isMessageFunction(a)?a:NOOP_MESSAGE_FUNCTION}};return e.processor&&(m.processor=e.processor),n.list&&(m.list=n.list),n.named&&(m.named=n.named),isNumber(n.plural)&&(m.pluralIndex=n.plural),m}const VERSION="12.0.0-alpha.2",I18nErrorCodes={UNEXPECTED_RETURN_TYPE:24,INVALID_ARGUMENT:25,MUST_BE_CALL_SETUP_TOP:26,NOT_INSTALLED:27,REQUIRED_VALUE:28,INVALID_VALUE:29,CANNOT_SETUP_VUE_DEVTOOLS_PLUGIN:30,NOT_INSTALLED_WITH_PROVIDE:31,UNEXPECTED_ERROR:32},TranslateVNodeSymbol=makeSymbol("__translateVNode"),DatetimePartsSymbol=makeSymbol("__datetimeParts"),NumberPartsSymbol=makeSymbol("__numberParts"),SetPluralRulesSymbol=makeSymbol("__setPluralRules"),InejctWithOptionSymbol=makeSymbol("__injectWithOption"),DisposeSymbol=makeSymbol("__dispose");function handleFlatJson(e){if(!isObject(e))return e;for(const t in e)if(hasOwn(e,t))if(t.includes(".")){const r=t.split("."),n=r.length-1;let o=e,a=!1;for(let e=0;e<n;e++){if("__proto__"===r[e])throw new Error(`unsafe key: ${r[e]}`);if(r[e]in o||(o[r[e]]=create()),!isObject(o[r[e]])){a=!0;break}o=o[r[e]]}a||(o[r[n]]=e[t],delete e[t]),isObject(o[r[n]])&&handleFlatJson(o[r[n]])}else isObject(e[t])&&handleFlatJson(e[t]);return e}function getLocaleMessages(e,t){const{messages:r,__i18n:n,messageResolver:o,flatJson:a}=t,s=isPlainObject(r)?r:isArray(n)?create():{[e]:create()};if(isArray(n)&&n.forEach((e=>{if("locale"in e&&"resource"in e){const{locale:t,resource:r}=e;t?(s[t]=s[t]||create(),deepCopy(r,s[t])):deepCopy(r,s)}else isString(e)&&deepCopy(JSON.parse(e),s)})),null==o&&a)for(const l in s)hasOwn(s,l)&&handleFlatJson(s[l]);return s}function getComponentOptions(e){return e.type}function adjustI18nResources(e,t,r){let n=isObject(t.messages)?t.messages:create();"__i18nGlobal"in r&&(n=getLocaleMessages(e.locale.value,{messages:n,__i18n:r.__i18nGlobal}));const o=Object.keys(n);if(o.length&&o.forEach((t=>{e.mergeLocaleMessage(t,n[t])})),isObject(t.datetimeFormats)){const r=Object.keys(t.datetimeFormats);r.length&&r.forEach((r=>{e.mergeDateTimeFormat(r,t.datetimeFormats[r])}))}if(isObject(t.numberFormats)){const r=Object.keys(t.numberFormats);r.length&&r.forEach((r=>{e.mergeNumberFormat(r,t.numberFormats[r])}))}}function createTextNode(e){return createVNode(Text,null,e,0)}const DEVTOOLS_META="__INTLIFY_META__",NOOP_RETURN_ARRAY=()=>[],NOOP_RETURN_FALSE=()=>!1;let composerID=0;function defineCoreMissingHandler(e){return(t,r,n,o)=>e(r,n,getCurrentInstance()||void 0,o)}const getMetaInfo=()=>{const e=getCurrentInstance();let t=null;return e&&(t=getComponentOptions(e)[DEVTOOLS_META])?{[DEVTOOLS_META]:t}:null};function createComposer(e={}){const{__root:t,__injectWithOption:r}=e,n=void 0===t,o=e.flatJson,a=inBrowser?ref:shallowRef;let s=!isBoolean(e.inheritLocale)||e.inheritLocale;const l=a(t&&s?t.locale.value:isString(e.locale)?e.locale:DEFAULT_LOCALE),i=a(t&&s?t.fallbackLocale.value:isString(e.fallbackLocale)||isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:l.value),c=a(getLocaleMessages(l.value,e)),u=a(isPlainObject(e.datetimeFormats)?e.datetimeFormats:{[l.value]:{}}),m=a(isPlainObject(e.numberFormats)?e.numberFormats:{[l.value]:{}});let f=t?t.missingWarn:!isBoolean(e.missingWarn)&&!isRegExp(e.missingWarn)||e.missingWarn,p=t?t.fallbackWarn:!isBoolean(e.fallbackWarn)&&!isRegExp(e.fallbackWarn)||e.fallbackWarn,E=t?t.fallbackRoot:!isBoolean(e.fallbackRoot)||e.fallbackRoot,_=!!e.fallbackFormat,g=isFunction(e.missing)?e.missing:null,d=isFunction(e.missing)?defineCoreMissingHandler(e.missing):null,b=isFunction(e.postTranslation)?e.postTranslation:null,C=t?t.warnHtmlMessage:!isBoolean(e.warnHtmlMessage)||e.warnHtmlMessage,O=!!e.escapeParameter;const S=t?t.modifiers:isPlainObject(e.modifiers)?e.modifiers:{};let T,L=e.pluralRules||t&&t.pluralRules;T=(()=>{n&&setFallbackContext(null);const t={version:VERSION,locale:l.value,fallbackLocale:i.value,messages:c.value,modifiers:S,pluralRules:L,missing:null===d?void 0:d,missingWarn:f,fallbackWarn:p,fallbackFormat:_,unresolving:!0,postTranslation:null===b?void 0:b,warnHtmlMessage:C,escapeParameter:O,messageResolver:e.messageResolver,messageCompiler:e.messageCompiler,__meta:{framework:"vue"}};t.datetimeFormats=u.value,t.numberFormats=m.value,t.__datetimeFormatters=isPlainObject(T)?T.__datetimeFormatters:void 0,t.__numberFormatters=isPlainObject(T)?T.__numberFormatters:void 0;const r=createCoreContext(t);return n&&setFallbackContext(r),r})(),updateFallbackLocale(T,l.value,i.value);const N=computed({get:()=>l.value,set:e=>{T.locale=e,l.value=e}}),A=computed({get:()=>i.value,set:e=>{T.fallbackLocale=e,i.value=e,updateFallbackLocale(T,l.value,e)}}),P=computed((()=>c.value)),y=computed((()=>Object.keys(c.value).sort())),h=computed((()=>u.value)),k=computed((()=>m.value));const I=(e,r,o,a,s,f)=>{let p;l.value,i.value,c.value,u.value,m.value;try{0,n||(T.fallbackContext=t?getFallbackContext():void 0),p=e(T)}finally{n||(T.fallbackContext=void 0)}if("translate exists"!==o&&isNumber(p)&&p===NOT_REOSLVED||"translate exists"===o&&!p){const[e,n]=r();return t&&E?a(t):s(e)}if(f(p))return p;throw Error(I18nErrorCodes.UNEXPECTED_RETURN_TYPE)};function R(...e){return I((t=>Reflect.apply(translate,null,[t,...e])),(()=>parseTranslateArgs(...e)),"translate",(t=>Reflect.apply(t.t,t,[...e])),(e=>e),(e=>isString(e)))}const F={normalize:function(e){return e.map((e=>isString(e)||isNumber(e)||isBoolean(e)?createTextNode(String(e)):e))},interpolate:e=>e,type:"vnode"};function v(e){return c.value[e]||{}}composerID++,t&&inBrowser&&(watch(t.locale,(e=>{s&&(l.value=e,T.locale=e,updateFallbackLocale(T,l.value,i.value))})),watch(t.fallbackLocale,(e=>{s&&(i.value=e,T.fallbackLocale=e,updateFallbackLocale(T,l.value,i.value))})));const D={id:composerID,locale:N,fallbackLocale:A,get inheritLocale(){return s},set inheritLocale(e){s=e,e&&t&&(l.value=t.locale.value,i.value=t.fallbackLocale.value,updateFallbackLocale(T,l.value,i.value))},availableLocales:y,messages:P,get modifiers(){return S},get pluralRules(){return L||{}},get isGlobal(){return n},get missingWarn(){return f},set missingWarn(e){f=e,T.missingWarn=f},get fallbackWarn(){return p},set fallbackWarn(e){p=e,T.fallbackWarn=p},get fallbackRoot(){return E},set fallbackRoot(e){E=e},get fallbackFormat(){return _},set fallbackFormat(e){_=e,T.fallbackFormat=_},get warnHtmlMessage(){return C},set warnHtmlMessage(e){C=e,T.warnHtmlMessage=e},get escapeParameter(){return O},set escapeParameter(e){O=e,T.escapeParameter=e},t:R,getLocaleMessage:v,setLocaleMessage:function(e,t){if(o){const r={[e]:t};for(const e in r)hasOwn(r,e)&&handleFlatJson(r[e]);t=r[e]}c.value[e]=t,T.messages=c.value},mergeLocaleMessage:function(e,t){c.value[e]=c.value[e]||{};const r={[e]:t};if(o)for(const n in r)hasOwn(r,n)&&handleFlatJson(r[n]);deepCopy(t=r[e],c.value[e]),T.messages=c.value},getPostTranslationHandler:function(){return isFunction(b)?b:null},setPostTranslationHandler:function(e){b=e,T.postTranslation=e},getMissingHandler:function(){return g},setMissingHandler:function(e){null!==e&&(d=defineCoreMissingHandler(e)),g=e,T.missing=d},[SetPluralRulesSymbol]:function(e){L=e,T.pluralRules=L}};return D.datetimeFormats=h,D.numberFormats=k,D.rt=function(...e){const[t,r,n]=e;if(n&&!isObject(n))throw Error(I18nErrorCodes.INVALID_ARGUMENT);return R(t,r,assign({resolvedMessage:!0},n||{}))},D.te=function(e,t){return I((()=>{if(!e)return!1;const r=v(isString(t)?t:l.value),n=T.messageResolver(r,e);return isMessageAST(n)||isMessageFunction(n)||isString(n)}),(()=>[e]),"translate exists",(r=>Reflect.apply(r.te,r,[e,t])),NOOP_RETURN_FALSE,(e=>isBoolean(e)))},D.tm=function(e){const r=function(e){let t=null;const r=fallbackWithLocaleChain(T,i.value,l.value);for(let n=0;n<r.length;n++){const o=c.value[r[n]]||{},a=T.messageResolver(o,e);if(null!=a){t=a;break}}return t}(e);return null!=r?r:t&&t.tm(e)||{}},D.d=function(...e){return I((t=>Reflect.apply(datetime,null,[t,...e])),(()=>parseDateTimeArgs(...e)),"datetime format",(t=>Reflect.apply(t.d,t,[...e])),(()=>MISSING_RESOLVE_VALUE),(e=>isString(e)))},D.n=function(...e){return I((t=>Reflect.apply(number,null,[t,...e])),(()=>parseNumberArgs(...e)),"number format",(t=>Reflect.apply(t.n,t,[...e])),(()=>MISSING_RESOLVE_VALUE),(e=>isString(e)))},D.getDateTimeFormat=function(e){return u.value[e]||{}},D.setDateTimeFormat=function(e,t){u.value[e]=t,T.datetimeFormats=u.value,clearDateTimeFormat(T,e,t)},D.mergeDateTimeFormat=function(e,t){u.value[e]=assign(u.value[e]||{},t),T.datetimeFormats=u.value,clearDateTimeFormat(T,e,t)},D.getNumberFormat=function(e){return m.value[e]||{}},D.setNumberFormat=function(e,t){m.value[e]=t,T.numberFormats=m.value,clearNumberFormat(T,e,t)},D.mergeNumberFormat=function(e,t){m.value[e]=assign(m.value[e]||{},t),T.numberFormats=m.value,clearNumberFormat(T,e,t)},D[InejctWithOptionSymbol]=r,D[TranslateVNodeSymbol]=function(...e){return I((t=>{let r;const n=t;try{n.processor=F,r=Reflect.apply(translate,null,[n,...e])}finally{n.processor=null}return r}),(()=>parseTranslateArgs(...e)),"translate",(t=>t[TranslateVNodeSymbol](...e)),(e=>[createTextNode(e)]),(e=>isArray(e)))},D[DatetimePartsSymbol]=function(...e){return I((t=>Reflect.apply(datetime,null,[t,...e])),(()=>parseDateTimeArgs(...e)),"datetime format",(t=>t[DatetimePartsSymbol](...e)),NOOP_RETURN_ARRAY,(e=>isString(e)||isArray(e)))},D[NumberPartsSymbol]=function(...e){return I((t=>Reflect.apply(number,null,[t,...e])),(()=>parseNumberArgs(...e)),"number format",(t=>t[NumberPartsSymbol](...e)),NOOP_RETURN_ARRAY,(e=>isString(e)||isArray(e)))},D}const BaseFormatPropsValidators={tag:{type:[String,Object]},locale:{type:String},scope:{type:String,validator:e=>"parent"===e||"global"===e,default:"parent"},i18n:{type:Object}};function getInterpolateArg({slots:e},t){if(1===t.length&&"default"===t[0]){return(e.default?e.default():[]).reduce(((e,t)=>[...e,...t.type===Fragment?t.children:[t]]),[])}return t.reduce(((t,r)=>{const n=e[r];return n&&(t[r]=n()),t}),create())}function getFragmentableTag(){return Fragment}function isVNode(e){return isArray(e)&&!isString(e[0])}function renderFormatter(e,t,r,n){const{slots:o,attrs:a}=t;return()=>{const t={part:!0};let s=create();e.locale&&(t.locale=e.locale),isString(e.format)?t.key=e.format:isObject(e.format)&&(isString(e.format.key)&&(t.key=e.format.key),s=Object.keys(e.format).reduce(((t,n)=>r.includes(n)?assign(create(),t,{[n]:e.format[n]}):t),create()));const l=n(e.value,t,s);let i=[t.key];isArray(l)?i=l.map(((e,t)=>{const r=o[e.type],n=r?r({[e.type]:e.value,index:t,parts:l}):[e.value];return isVNode(n)&&(n[0].key=`${e.type}-${t}`),n})):isString(l)&&(i=[l]);const c=assign(create(),a),u=isString(e.tag)||isObject(e.tag)?e.tag:getFragmentableTag();return h(u,c,i)}}const DatetimeFormatImpl=defineComponent({name:"i18n-d",props:assign({value:{type:[Number,Date],required:!0},format:{type:[String,Object]}},BaseFormatPropsValidators),setup(e,t){const r=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return renderFormatter(e,t,DATETIME_FORMAT_OPTIONS_KEYS,((...e)=>r[DatetimePartsSymbol](...e)))}}),DatetimeFormat=DatetimeFormatImpl,NumberFormatImpl=defineComponent({name:"i18n-n",props:assign({value:{type:Number,required:!0},format:{type:[String,Object]}},BaseFormatPropsValidators),setup(e,t){const r=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return renderFormatter(e,t,NUMBER_FORMAT_OPTIONS_KEYS,((...e)=>r[NumberPartsSymbol](...e)))}}),NumberFormat=NumberFormatImpl,TranslationImpl=defineComponent({name:"i18n-t",props:assign({},{keypath:{type:String,required:!0},plural:{type:[Number,String],validator:e=>isNumber(e)||!isNaN(e)}},BaseFormatPropsValidators),setup(e,t){const{slots:r,attrs:n}=t,o=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return()=>{const a=Object.keys(r).filter((e=>"_"!==e)),s=create();e.locale&&(s.locale=e.locale),void 0!==e.plural&&(s.plural=isString(e.plural)?+e.plural:e.plural);const l=getInterpolateArg(t,a),i=o[TranslateVNodeSymbol](e.keypath,l,s),c=assign(create(),n),u=isString(e.tag)||isObject(e.tag)?e.tag:getFragmentableTag();return h(u,c,i)}}}),Translation=TranslationImpl;function apply(e,...t){const r=isPlainObject(t[0])?t[0]:{};(!isBoolean(r.globalInstall)||r.globalInstall)&&([Translation.name,"I18nT"].forEach((t=>e.component(t,Translation))),[NumberFormat.name,"I18nN"].forEach((t=>e.component(t,NumberFormat))),[DatetimeFormat.name,"I18nD"].forEach((t=>e.component(t,DatetimeFormat))))}const I18nInjectionKey=makeSymbol("global-vue-i18n");function createI18n(e={}){const t=!isBoolean(e.globalInjection)||e.globalInjection,r=new Map,[n,o]=createGlobal(e),a=makeSymbol("");const s={async install(e,...r){if(e.__VUE_I18N_SYMBOL__=a,e.provide(e.__VUE_I18N_SYMBOL__,s),isPlainObject(r[0])){const e=r[0];s.__composerExtend=e.__composerExtend}let n=null;t&&(n=injectGlobalFields(e,s.global)),apply(e,...r);const o=e.unmount;e.unmount=()=>{n&&n(),s.dispose(),o()}},get global(){return o},dispose(){n.stop()},__instances:r,__getInstance:function(e){return r.get(e)||null},__setInstance:function(e,t){r.set(e,t)},__deleteInstance:function(e){r.delete(e)}};return s}function useI18n(e={}){const t=getCurrentInstance();if(null==t)throw Error(I18nErrorCodes.MUST_BE_CALL_SETUP_TOP);if(!t.isCE&&null!=t.appContext.app&&!t.appContext.app.__VUE_I18N_SYMBOL__)throw Error(I18nErrorCodes.NOT_INSTALLED);const r=getI18nInstance(t),n=getGlobalComposer(r),o=getComponentOptions(t),a=getScope(e,o);if("global"===a)return adjustI18nResources(n,e,o),n;if("parent"===a){let o=getComposer(r,t,e.__useComponent);return null==o&&(o=n),o}const s=r;let l=s.__getInstance(t);if(null==l){const r=assign({},e);"__i18n"in o&&(r.__i18n=o.__i18n),n&&(r.__root=n),l=createComposer(r),s.__composerExtend&&(l[DisposeSymbol]=s.__composerExtend(l)),setupLifeCycle(s,t,l),s.__setInstance(t,l)}return l}function createGlobal(e){const t=effectScope(),r=t.run((()=>createComposer(e)));if(null==r)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);return[t,r]}function getI18nInstance(e){const t=inject(e.isCE?I18nInjectionKey:e.appContext.app.__VUE_I18N_SYMBOL__);if(!t)throw Error(e.isCE?I18nErrorCodes.NOT_INSTALLED_WITH_PROVIDE:I18nErrorCodes.UNEXPECTED_ERROR);return t}function getScope(e,t){return isEmptyObject(e)?"__i18n"in t?"local":"global":e.useScope?e.useScope:"local"}function getGlobalComposer(e){return e.global}function getComposer(e,t,r=!1){let n=null;const o=t.root;let a=getParentComponentInstance(t,r);for(;null!=a;){if(n=e.__getInstance(a),null!=n)break;if(o===a)break;a=a.parent}return n}function getParentComponentInstance(e,t=!1){return null==e?null:t&&e.vnode.ctx||e.parent}function setupLifeCycle(e,t,r){onMounted((()=>{}),t),onUnmounted((()=>{const n=r;e.__deleteInstance(t);const o=n[DisposeSymbol];o&&(o(),delete n[DisposeSymbol])}),t)}const globalExportProps=["locale","fallbackLocale","availableLocales"],globalExportMethods=["t","rt","d","n","tm","te"];function injectGlobalFields(e,t){const r=Object.create(null);globalExportProps.forEach((e=>{const n=Object.getOwnPropertyDescriptor(t,e);if(!n)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const o=isRef(n.value)?{get:()=>n.value.value,set(e){n.value.value=e}}:{get:()=>n.get&&n.get()};Object.defineProperty(r,e,o)})),e.config.globalProperties.$i18n=r,globalExportMethods.forEach((r=>{const n=Object.getOwnPropertyDescriptor(t,r);if(!n||!n.value)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);Object.defineProperty(e.config.globalProperties,`$${r}`,n)}));return()=>{delete e.config.globalProperties.$i18n,globalExportMethods.forEach((t=>{delete e.config.globalProperties[`$${t}`]}))}}registerMessageCompiler(compile),registerMessageResolver(resolveValue),registerLocaleFallbacker(fallbackWithLocaleChain);export{I18nInjectionKey,VERSION,createI18n,useI18n};
